how2j.cn


工具版本兼容问题
异常处理常见手段: try catch finally throws


本视频是解读性视频,所以希望您已经看过了本知识点的内容,并且编写了相应的代码之后,带着疑问来观看,这样收获才多。 不建议一开始就观看视频



11分35秒
本视频采用html5方式播放,如无法正常播放,请将浏览器升级至最新版本,推荐火狐,chrome,360浏览器。 如果装有迅雷,播放视频呈现直接下载状态,请调整 迅雷系统设置-基本设置-启动-监视全部浏览器 (去掉这个选项)。 chrome 的 视频下载插件会影响播放,如 IDM 等,请关闭或者切换其他浏览器



步骤 1 : try catch   
步骤 2 : 使用异常的父类进行catch   
步骤 3 : 多异常捕捉办法1   
步骤 4 : 多异常捕捉办法2   
步骤 5 : finally   
步骤 6 : throws   
步骤 7 : throw和throws的区别   
步骤 8 : 练习-异常处理   
步骤 9 : 答案-异常处理   

1.将可能抛出FileNotFoundException 文件不存在异常的代码放在try里
2.如果文件存在,就会顺序往下执行,并且不执行catch块中的代码
3. 如果文件不存在,try 里的代码会立即终止,程序流程会运行到对应的catch块中
4. e.printStackTrace(); 会打印出方法的调用痕迹,如此例,会打印出异常开始于TestException的第16行,这样就便于定位和分析到底哪里出了异常
try catch
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; public class TestException { public static void main(String[] args) { File f= new File("d:/LOL.exe"); try{ System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); } catch(FileNotFoundException e){ System.out.println("d:/LOL.exe不存在"); e.printStackTrace(); } } }
步骤 2 :

使用异常的父类进行catch

edit
FileNotFoundException是Exception的子类,使用Exception也可以catch住FileNotFoundException
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; public class TestException { public static void main(String[] args) { File f= new File("d:/LOL.exe"); try{ System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); } catch(Exception e){ System.out.println("d:/LOL.exe不存在"); e.printStackTrace(); } } }
步骤 3 :

多异常捕捉办法1

edit
有的时候一段代码会抛出多种异常,比如

new FileInputStream(f);
Date d = sdf.parse("2016-06-03");

这段代码,会抛出 文件不存在异常 FileNotFoundException 和 解析异常ParseException
解决办法之一是分别进行catch

catch (FileNotFoundException e) {
System.out.println("d:/LOL.exe不存在");
e.printStackTrace();
} catch (ParseException e) {
System.out.println("日期格式解析错误");
e.printStackTrace();
}
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; import java.text.ParseException; import java.text.SimpleDateFormat; import java.util.Date; public class TestException { public static void main(String[] args) { File f = new File("d:/LOL.exe"); try { System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd"); Date d = sdf.parse("2016-06-03"); } catch (FileNotFoundException e) { System.out.println("d:/LOL.exe不存在"); e.printStackTrace(); } catch (ParseException e) { System.out.println("日期格式解析错误"); e.printStackTrace(); } } }
步骤 4 :

多异常捕捉办法2

edit
另一个种办法是把多个异常,放在一个catch里统一捕捉

catch (FileNotFoundException | ParseException e) {

这种方式从 JDK7开始支持,好处是捕捉的代码更紧凑,不足之处是,一旦发生异常,不能确定到底是哪种异常,需要通过instanceof 进行判断具体的异常类型

if (e instanceof FileNotFoundException)
System.out.println("d:/LOL.exe不存在");
if (e instanceof ParseException)
System.out.println("日期格式解析错误");
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; import java.text.ParseException; import java.text.SimpleDateFormat; import java.util.Date; public class TestException { public static void main(String[] args) { File f = new File("d:/LOL.exe"); try { System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd"); Date d = sdf.parse("2016-06-03"); } catch (FileNotFoundException | ParseException e) { if (e instanceof FileNotFoundException) System.out.println("d:/LOL.exe不存在"); if (e instanceof ParseException) System.out.println("日期格式解析错误"); e.printStackTrace(); } } }
无论是否出现异常,finally中的代码都会被执行
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; public class TestException { public static void main(String[] args) { File f= new File("d:/LOL.exe"); try{ System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); } catch(FileNotFoundException e){ System.out.println("d:/LOL.exe不存在"); e.printStackTrace(); } finally{ System.out.println("无论文件是否存在, 都会执行的代码"); } } }
考虑如下情况:
主方法调用method1
method1调用method2
method2中打开文件

method2中需要进行异常处理
但是method2不打算处理,而是把这个异常通过throws抛出去
那么method1就会接到该异常。 处理办法也是两种,要么是try catch处理掉,要么也是抛出去
method1选择本地try catch住 一旦try catch住了,就相当于把这个异常消化掉了,主方法在调用method1的时候,就不需要进行异常处理了
package exception; import java.io.File; import java.io.FileInputStream; import java.io.FileNotFoundException; public class TestException { public static void main(String[] args) { method1(); } private static void method1() { try { method2(); } catch (FileNotFoundException e) { // TODO Auto-generated catch block e.printStackTrace(); } } private static void method2() throws FileNotFoundException { File f = new File("d:/LOL.exe"); System.out.println("试图打开 d:/LOL.exe"); new FileInputStream(f); System.out.println("成功打开"); } }
步骤 7 :

throw和throws的区别

edit
throws与throw这两个关键字接近,不过意义不一样,有如下区别:
1. throws 出现在方法声明上,而throw通常都出现在方法体内。
2. throws 表示出现异常的一种可能性,并不一定会发生这些异常;throw则是抛出了异常,执行throw则一定抛出了某个异常对象。
步骤 8 :

练习-异常处理

edit  姿势不对,事倍功半! 点击查看做练习的正确姿势
假设有一个方法 public int method(), 会返回一个整数
在这个方法中有try catch 和 finally.
try 里返回 1
catch 里 返回 2
finally 里 返回3
那么,这个方法到底返回多少?
步骤 9 :

答案-异常处理

edit
在查看答案前,尽量先自己完成,碰到问题再来查看答案,收获会更多
在查看答案前,尽量先自己完成,碰到问题再来查看答案,收获会更多
在查看答案前,尽量先自己完成,碰到问题再来查看答案,收获会更多
查看本答案会花费3个积分,您目前总共有点积分。查看相同答案不会花费额外积分。 积分增加办法 或者一次性购买JAVA 中级总计0个答案 (总共需要0积分)
查看本答案会花费3个积分,您目前总共有点积分。查看相同答案不会花费额外积分。 积分增加办法 或者一次性购买JAVA 中级总计0个答案 (总共需要0积分)
账号未激活 账号未激活,功能受限。 请点击激活
本视频是解读性视频,所以希望您已经看过了本答案的内容,带着疑问来观看,这样收获才多。 不建议一开始就观看视频

3分32秒 本视频采用html5方式播放,如无法正常播放,请将浏览器升级至最新版本,推荐火狐,chrome,360浏览器。 如果装有迅雷,播放视频呈现直接下载状态,请调整 迅雷系统设置-基本设置-启动-监视全部浏览器 (去掉这个选项)。 chrome 的 视频下载插件会影响播放,如 IDM 等,请关闭或者切换其他浏览器


可以看到,最后结果是取finally的返回值3.
同时,故意把method设计成调用 return1(),return2(),return3()。
可以观察到,try里的 返回和 finally的返回都是执行了的,不过最后选择使用finally里的返回的值
答案-异常处理
package exception; public class TestException { public static int method() { try { return return1(); } catch (Exception e) { return return2(); } finally { return return3(); } } private static int return1() { System.out.println("return 1"); return 1; } private static int return2() { System.out.println("return 2"); return 2; } private static int return3() { System.out.println("return 3"); return 3; } public static void main(String[] args) { int result = method(); System.out.println("result:" + result); } }


HOW2J公众号,关注后实时获知最新的教程和优惠活动,谢谢。


问答区域    
2022-05-12 3
大D




返回3
public static void main(String[] args)  {
       // method1();
      int a=  getresult();
        System.out.println(a);
    }
public static int getresult(){
        File f=new File("d:/");
       try {
           new FileInputStream(f);
           return 1;
       }catch (FileNotFoundException e){
           e.printStackTrace();
           return 2;
       }finally {
           return 3;
       }
    }

							


1 个答案

JACKBLACK
答案时间:2022-07-19
返回2和3,你把fanally去掉就是2了



回答已经提交成功,正在审核。 请于 我的回答 处查看回答记录,谢谢
答案 或者 代码至少填写一项, 如果是自己有问题,请重新提问,否则站长有可能看不到





2022-05-07 通过thow引发异常
芬达味橘猫




如果没有捕获异常,作业中会返回1,3 捕获到异常的话,会返回2,3 无论如何最终都会执行finally的内容
import java.io.FileNotFoundException;

public class Test04 {

    public int method1() throws FileNotFoundException  {
        int a = (int) (Math.random() * 100);
        //引发异常
        throw new FileNotFoundException("文件丢失");
        }
    public static void main(String[] args) {
        Test04 result =  new Test04();
        try{
            result.method1();
            System.out.println(1);
        }
        catch (Exception e) {
            System.out.println(2);
            e.printStackTrace();
        }
        finally {
            System.out.println(3);
        }
    }


}

							


1 个答案

撤水码农
答案时间:2022-06-08
错误的,事实上finally代码块的内容必须执行,因此会忽视掉其他的return。 所以值只在finally return 3变化一次。



回答已经提交成功,正在审核。 请于 我的回答 处查看回答记录,谢谢
答案 或者 代码至少填写一项, 如果是自己有问题,请重新提问,否则站长有可能看不到





2021-11-30 测试练习
2021-08-23 我的理解
2021-05-19 异常处理


提问太多,页面渲染太慢,为了加快渲染速度,本页最多只显示几条提问。还有 34 条以前的提问,请 点击查看

提问之前请登陆
提问已经提交成功,正在审核。 请于 我的提问 处查看提问记录,谢谢
关于 JAVA 中级-异常处理-处理 的提问

尽量提供截图代码异常信息,有助于分析和解决问题。 也可进本站QQ群交流: 578362961
提问尽量提供完整的代码,环境描述,越是有利于问题的重现,您的问题越能更快得到解答。
对教程中代码有疑问,请提供是哪个步骤,哪一行有疑问,这样便于快速定位问题,提高问题得到解答的速度
在已经存在的几千个提问里,有相当大的比例,是因为使用了和站长不同版本的开发环境导致的,比如 jdk, eclpise, idea, mysql,tomcat 等等软件的版本不一致。
请使用和站长一样的版本,可以节约自己大量的学习时间。 站长把教学中用的软件版本整理了,都统一放在了这里, 方便大家下载: https://how2j.cn/k/helloworld/helloworld-version/1718.html

上传截图